
#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <string.h>

#include <gtk/gtk.h>
#include "gui/interface.h"
#include "gui/support.h"
#include "gui/callbacks.h"


#include "generateParameter.h"
#include "applicationGUI.h"
#include <grp.h>
#include <unistd.h>

 GtkWidget               *window;

char* defaultGroups[]= 
		{"fuse","cdrom","video","optical", 
		"tty","lp","mail","network","audio", 
		"floppy","storage","scanner","power",
		"users","hal",0};

GtkWidget * widgetFromWindow(const char* aName)
{
        return  lookup_widget(window,aName);
}

int isInADefaultGroup(const char  * group)
{
	char**	dGroups= defaultGroups;
	while (*dGroups)
	{
		if (strcmp(*dGroups, group)==0)
			return 1;
		dGroups++;
	}
	return 0;
}
int main (int argc, char *argv[])
{
 struct group * gr;

  gtk_init (&argc, &argv);
 add_pixmap_directory (PACKAGE_DATA_DIR "/pixmaps");
  
  if  (access("/etc/shadow",R_OK))
  {
	if (access("/etc/shadow",R_OK)==-1)
	{
		
    		GtkMessageDialog * errorMessage=(GtkMessageDialog *) gtk_message_dialog_new(NULL, \
		   GTK_DIALOG_MODAL , GTK_MESSAGE_ERROR,GTK_BUTTONS_CLOSE,"Este programa necesita privilegios de administrador");

  		 gtk_dialog_run((GtkDialog*)errorMessage);
		 gtk_widget_destroy ((GtkWidget*)errorMessage);
		 return 0;		
	}

  } 
  
  window = create_addUserWindow();
  
  
  setgrent();  
  int groupsCount=0;  
  while ((gr=getgrent()))
  {    
    groupsCount++;
  }
  endgrent();
  GtkWidget*  table=lookup_widget(window,"tblGroupContainer");
  gtk_table_resize   (GTK_TABLE(table),groupsCount/3,3);
  gtk_table_set_homogeneous (GTK_TABLE(table),0);
  setgrent();  
  int row=0;
  int col=0;
  GtkWidget* chkbutton;
  while ((gr=getgrent()))
  {    
    chkbutton=gtk_check_button_new_with_label((const gchar*)gr->gr_name);
    gtk_widget_show(GTK_WIDGET(chkbutton));
    if (isInADefaultGroup(gr->gr_name))
    {
	gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(chkbutton),1);
    }
    gtk_table_attach (GTK_TABLE(table),GTK_WIDGET(chkbutton),col,col+1,row,row+1, GTK_EXPAND | GTK_FILL,GTK_EXPAND | GTK_FILL,0,0);
    col++;   
    if (col==3)
    {
      col=0;
      row++;
    }
    
  }
    
 
  endgrent();
 
  
  
         
  
  gtk_widget_show (window); 
  
  gtk_main ();

  return 0;
}
